﻿using System;
using System.Web.Mvc;
using Syncfusion.JavaScript;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Web;
using System.Web.Http;
using System.Web.Script.Serialization;
namespace SyncfusionMvcApplication4
{
     public partial class FileExplorerController: Controller
    {
        public ActionResult FileExplorerFeatures()
        {
              return View();
        }
        public ActionResult FileActionDefault(FileExplorerParams args)
        {
            FileExplorerOperations opeartion = new FileExplorerOperations();
            switch (args.ActionType)
            {
                case "Read":
                    return Json(opeartion.Read(args.Path, args.ExtensionsAllow));
                case "CreateFolder":
                    return Json(opeartion.CreateFolder(args.Path, args.Name));
                case "Paste":
                    return Json(opeartion.Paste(args.LocationFrom, args.LocationTo, args.Names, args.Action, args.CommonFiles));
                case "Remove":
                    return Json(opeartion.Remove(args.Names, args.Path));
                case "Rename":
                    return Json(opeartion.Rename(args.Path, args.Name, args.NewName, args.CommonFiles));
                case "GetDetails":
                    return Json(opeartion.GetDetails(args.Path, args.Names));
                case "Download":
                    opeartion.Download(args.Path, args.Names);
                    break;
                case "Upload":
                    opeartion.Upload(args.FileUpload, args.Path);
                    break;
                case "Search":
                    return Json(opeartion.Search(args.Path, args.ExtensionsAllow, args.SearchString, args.CaseSensitive));
            }
            return Json("");
        }
        public ActionResult ImportExport()
        {
            return View();
        }
        [System.Web.Mvc.HttpPost]
        public object Importing(string FilePath)
        {
            string HtmlString = string.Empty;
            string path = System.Web.HttpContext.Current.Server.MapPath(FilePath);

            //var path = FilePath;

            if (path != null)
            {
                using (var mStream = new MemoryStream())
                {
                    new WordDocument(path).Save(mStream, FormatType.Html);
                    mStream.Position = 0;
                    HtmlString = new StreamReader(mStream).ReadToEnd();
                };

                HtmlString = ExtractBodyContent(HtmlString);

                foreach (var item in DecodeKeys())
                {
                    HtmlString = HtmlString.Replace(item.Key, item.Value);
                }
            }
            else HttpContext.Response.Write("Select any file to upload.");
            return Json(HtmlString);
        }

        public IDictionary<string, string> DecodeKeys()
        {
            IDictionary<string, string> KeyValuePair = new Dictionary<string, string>()
            {
               {"\"", "'"},{"\r", " "},{"\n", "<br/> "},{"\r\n", " "},{"( )+", " "},{"&nbsp;", " "},{"&bull;", "*"},{"&lsaquo;", "<"},
               {"&rsaquo;", ">"},{"&trade;", "(tm)"},{"&copy;", "(c)"},{"&reg;", "(r)"}
            };

            return KeyValuePair;
        }

        public string ExtractBodyContent(string html)
        {
            if (html.Contains("<html") && html.Contains("<body"))
            {
                return html.Remove(0, html.IndexOf("<body>") + 6).Replace("</body></html>", "");

            }
            return html;
        }
    }
}
